
/* Generated data (by glib-mkenums) */

#include "mm-daemon-enums-types.h"
/* enumerations from "./mm-base-bearer.h" */
static const GEnumValue mm_bearer_status_values[] = {
    { MM_BEARER_STATUS_DISCONNECTED, "MM_BEARER_STATUS_DISCONNECTED", "disconnected" },
    { MM_BEARER_STATUS_DISCONNECTING, "MM_BEARER_STATUS_DISCONNECTING", "disconnecting" },
    { MM_BEARER_STATUS_CONNECTING, "MM_BEARER_STATUS_CONNECTING", "connecting" },
    { MM_BEARER_STATUS_CONNECTED, "MM_BEARER_STATUS_CONNECTED", "connected" },
    { 0, NULL, NULL }
};

/* Define type-specific symbols */
#undef __MM_IS_ENUM__
#undef __MM_IS_FLAGS__
#define __MM_IS_ENUM__

GType
mm_bearer_status_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_enum_register_static (g_intern_static_string ("MMBearerStatus"),
                                      mm_bearer_status_values);
        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * mm_bearer_status_get_string:
 * @val: a MMBearerStatus.
 *
 * Gets the nickname string for the #MMBearerStatus specified at @val.
 *
 * Returns: (transfer none): a string with the nickname, or %NULL if not found. Do not free the returned value.
 */
#if defined __MM_IS_ENUM__
const gchar *
mm_bearer_status_get_string (MMBearerStatus val)
{
    guint i;

    for (i = 0; mm_bearer_status_values[i].value_nick; i++) {
        if (val == mm_bearer_status_values[i].value)
            return mm_bearer_status_values[i].value_nick;
    }

    return NULL;
}
#endif /* __MM_IS_ENUM_ */

/**
 * mm_bearer_status_build_string_from_mask:
 * @mask: bitmask of MMBearerStatus values.
 *
 * Builds a string containing a comma-separated list of nicknames for
 * each #MMBearerStatus in @mask.
 *
 * Returns: (transfer full): a string with the list of nicknames, or %NULL if none given. The returned value should be freed with g_free().
 */
#if defined __MM_IS_FLAGS__
gchar *
mm_bearer_status_build_string_from_mask (MMBearerStatus mask)
{
    guint i;
    gboolean first = TRUE;
    GString *str = NULL;

    for (i = 0; mm_bearer_status_values[i].value_nick; i++) {
        /* We also look for exact matches */
        if (mask == mm_bearer_status_values[i].value) {
            if (str)
                g_string_free (str, TRUE);
            return g_strdup (mm_bearer_status_values[i].value_nick);
        }

        /* Build list with single-bit masks */
        if (mask & mm_bearer_status_values[i].value) {
            guint c;
            gulong number = mm_bearer_status_values[i].value;

            for (c = 0; number; c++)
                number &= number - 1;

            if (c == 1) {
                if (!str)
                    str = g_string_new ("");
                g_string_append_printf (str, "%s%s",
                                        first ? "" : ", ",
                                        mm_bearer_status_values[i].value_nick);
                if (first)
                    first = FALSE;
            }
        }
    }

    return (str ? g_string_free (str, FALSE) : NULL);
}
#endif /* __MM_IS_FLAGS__ */

static const GEnumValue mm_bearer_connection_status_values[] = {
    { MM_BEARER_CONNECTION_STATUS_UNKNOWN, "MM_BEARER_CONNECTION_STATUS_UNKNOWN", "unknown" },
    { MM_BEARER_CONNECTION_STATUS_DISCONNECTED, "MM_BEARER_CONNECTION_STATUS_DISCONNECTED", "disconnected" },
    { MM_BEARER_CONNECTION_STATUS_DISCONNECTING, "MM_BEARER_CONNECTION_STATUS_DISCONNECTING", "disconnecting" },
    { MM_BEARER_CONNECTION_STATUS_CONNECTED, "MM_BEARER_CONNECTION_STATUS_CONNECTED", "connected" },
    { MM_BEARER_CONNECTION_STATUS_CONNECTION_FAILED, "MM_BEARER_CONNECTION_STATUS_CONNECTION_FAILED", "connection-failed" },
    { 0, NULL, NULL }
};

/* Define type-specific symbols */
#undef __MM_IS_ENUM__
#undef __MM_IS_FLAGS__
#define __MM_IS_ENUM__

GType
mm_bearer_connection_status_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_enum_register_static (g_intern_static_string ("MMBearerConnectionStatus"),
                                      mm_bearer_connection_status_values);
        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * mm_bearer_connection_status_get_string:
 * @val: a MMBearerConnectionStatus.
 *
 * Gets the nickname string for the #MMBearerConnectionStatus specified at @val.
 *
 * Returns: (transfer none): a string with the nickname, or %NULL if not found. Do not free the returned value.
 */
#if defined __MM_IS_ENUM__
const gchar *
mm_bearer_connection_status_get_string (MMBearerConnectionStatus val)
{
    guint i;

    for (i = 0; mm_bearer_connection_status_values[i].value_nick; i++) {
        if (val == mm_bearer_connection_status_values[i].value)
            return mm_bearer_connection_status_values[i].value_nick;
    }

    return NULL;
}
#endif /* __MM_IS_ENUM_ */

/**
 * mm_bearer_connection_status_build_string_from_mask:
 * @mask: bitmask of MMBearerConnectionStatus values.
 *
 * Builds a string containing a comma-separated list of nicknames for
 * each #MMBearerConnectionStatus in @mask.
 *
 * Returns: (transfer full): a string with the list of nicknames, or %NULL if none given. The returned value should be freed with g_free().
 */
#if defined __MM_IS_FLAGS__
gchar *
mm_bearer_connection_status_build_string_from_mask (MMBearerConnectionStatus mask)
{
    guint i;
    gboolean first = TRUE;
    GString *str = NULL;

    for (i = 0; mm_bearer_connection_status_values[i].value_nick; i++) {
        /* We also look for exact matches */
        if (mask == mm_bearer_connection_status_values[i].value) {
            if (str)
                g_string_free (str, TRUE);
            return g_strdup (mm_bearer_connection_status_values[i].value_nick);
        }

        /* Build list with single-bit masks */
        if (mask & mm_bearer_connection_status_values[i].value) {
            guint c;
            gulong number = mm_bearer_connection_status_values[i].value;

            for (c = 0; number; c++)
                number &= number - 1;

            if (c == 1) {
                if (!str)
                    str = g_string_new ("");
                g_string_append_printf (str, "%s%s",
                                        first ? "" : ", ",
                                        mm_bearer_connection_status_values[i].value_nick);
                if (first)
                    first = FALSE;
            }
        }
    }

    return (str ? g_string_free (str, FALSE) : NULL);
}
#endif /* __MM_IS_FLAGS__ */

/* enumerations from "./mm-port-probe.h" */
static const GFlagsValue mm_port_probe_flag_values[] = {
    { MM_PORT_PROBE_NONE, "MM_PORT_PROBE_NONE", "none" },
    { MM_PORT_PROBE_AT, "MM_PORT_PROBE_AT", "at" },
    { MM_PORT_PROBE_AT_VENDOR, "MM_PORT_PROBE_AT_VENDOR", "at-vendor" },
    { MM_PORT_PROBE_AT_PRODUCT, "MM_PORT_PROBE_AT_PRODUCT", "at-product" },
    { MM_PORT_PROBE_AT_ICERA, "MM_PORT_PROBE_AT_ICERA", "at-icera" },
    { MM_PORT_PROBE_QCDM, "MM_PORT_PROBE_QCDM", "qcdm" },
    { MM_PORT_PROBE_QMI, "MM_PORT_PROBE_QMI", "qmi" },
    { MM_PORT_PROBE_MBIM, "MM_PORT_PROBE_MBIM", "mbim" },
    { 0, NULL, NULL }
};

/* Define type-specific symbols */
#undef __MM_IS_ENUM__
#undef __MM_IS_FLAGS__
#define __MM_IS_FLAGS__

GType
mm_port_probe_flag_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_flags_register_static (g_intern_static_string ("MMPortProbeFlag"),
                                      mm_port_probe_flag_values);
        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * mm_port_probe_flag_get_string:
 * @val: a MMPortProbeFlag.
 *
 * Gets the nickname string for the #MMPortProbeFlag specified at @val.
 *
 * Returns: (transfer none): a string with the nickname, or %NULL if not found. Do not free the returned value.
 */
#if defined __MM_IS_ENUM__
const gchar *
mm_port_probe_flag_get_string (MMPortProbeFlag val)
{
    guint i;

    for (i = 0; mm_port_probe_flag_values[i].value_nick; i++) {
        if (val == mm_port_probe_flag_values[i].value)
            return mm_port_probe_flag_values[i].value_nick;
    }

    return NULL;
}
#endif /* __MM_IS_ENUM_ */

/**
 * mm_port_probe_flag_build_string_from_mask:
 * @mask: bitmask of MMPortProbeFlag values.
 *
 * Builds a string containing a comma-separated list of nicknames for
 * each #MMPortProbeFlag in @mask.
 *
 * Returns: (transfer full): a string with the list of nicknames, or %NULL if none given. The returned value should be freed with g_free().
 */
#if defined __MM_IS_FLAGS__
gchar *
mm_port_probe_flag_build_string_from_mask (MMPortProbeFlag mask)
{
    guint i;
    gboolean first = TRUE;
    GString *str = NULL;

    for (i = 0; mm_port_probe_flag_values[i].value_nick; i++) {
        /* We also look for exact matches */
        if (mask == mm_port_probe_flag_values[i].value) {
            if (str)
                g_string_free (str, TRUE);
            return g_strdup (mm_port_probe_flag_values[i].value_nick);
        }

        /* Build list with single-bit masks */
        if (mask & mm_port_probe_flag_values[i].value) {
            guint c;
            gulong number = mm_port_probe_flag_values[i].value;

            for (c = 0; number; c++)
                number &= number - 1;

            if (c == 1) {
                if (!str)
                    str = g_string_new ("");
                g_string_append_printf (str, "%s%s",
                                        first ? "" : ", ",
                                        mm_port_probe_flag_values[i].value_nick);
                if (first)
                    first = FALSE;
            }
        }
    }

    return (str ? g_string_free (str, FALSE) : NULL);
}
#endif /* __MM_IS_FLAGS__ */


/* Generated data ends here */

