
/* Generated data (by glib-mkenums) */

#include "mm-port-enums-types.h"
/* enumerations from "./mm-port.h" */
static const GEnumValue mm_port_subsys_values[] = {
    { MM_PORT_SUBSYS_UNKNOWN, "MM_PORT_SUBSYS_UNKNOWN", "unknown" },
    { MM_PORT_SUBSYS_TTY, "MM_PORT_SUBSYS_TTY", "tty" },
    { MM_PORT_SUBSYS_NET, "MM_PORT_SUBSYS_NET", "net" },
    { MM_PORT_SUBSYS_USB, "MM_PORT_SUBSYS_USB", "usb" },
    { MM_PORT_SUBSYS_UNIX, "MM_PORT_SUBSYS_UNIX", "unix" },
    { 0, NULL, NULL }
};

/* Define type-specific symbols */
#undef __MM_IS_ENUM__
#undef __MM_IS_FLAGS__
#define __MM_IS_ENUM__

GType
mm_port_subsys_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_enum_register_static (g_intern_static_string ("MMPortSubsys"),
                                      mm_port_subsys_values);
        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * mm_port_subsys_get_string:
 * @val: a MMPortSubsys.
 *
 * Gets the nickname string for the #MMPortSubsys specified at @val.
 *
 * Returns: (transfer none): a string with the nickname, or %NULL if not found. Do not free the returned value.
 */
#if defined __MM_IS_ENUM__
const gchar *
mm_port_subsys_get_string (MMPortSubsys val)
{
    guint i;

    for (i = 0; mm_port_subsys_values[i].value_nick; i++) {
        if (val == mm_port_subsys_values[i].value)
            return mm_port_subsys_values[i].value_nick;
    }

    return NULL;
}
#endif /* __MM_IS_ENUM_ */

/**
 * mm_port_subsys_build_string_from_mask:
 * @mask: bitmask of MMPortSubsys values.
 *
 * Builds a string containing a comma-separated list of nicknames for
 * each #MMPortSubsys in @mask.
 *
 * Returns: (transfer full): a string with the list of nicknames, or %NULL if none given. The returned value should be freed with g_free().
 */
#if defined __MM_IS_FLAGS__
gchar *
mm_port_subsys_build_string_from_mask (MMPortSubsys mask)
{
    guint i;
    gboolean first = TRUE;
    GString *str = NULL;

    for (i = 0; mm_port_subsys_values[i].value_nick; i++) {
        /* We also look for exact matches */
        if (mask == mm_port_subsys_values[i].value) {
            if (str)
                g_string_free (str, TRUE);
            return g_strdup (mm_port_subsys_values[i].value_nick);
        }

        /* Build list with single-bit masks */
        if (mask & mm_port_subsys_values[i].value) {
            guint c;
            gulong number = mm_port_subsys_values[i].value;

            for (c = 0; number; c++)
                number &= number - 1;

            if (c == 1) {
                if (!str)
                    str = g_string_new ("");
                g_string_append_printf (str, "%s%s",
                                        first ? "" : ", ",
                                        mm_port_subsys_values[i].value_nick);
                if (first)
                    first = FALSE;
            }
        }
    }

    return (str ? g_string_free (str, FALSE) : NULL);
}
#endif /* __MM_IS_FLAGS__ */

static const GEnumValue mm_port_type_values[] = {
    { MM_PORT_TYPE_UNKNOWN, "MM_PORT_TYPE_UNKNOWN", "unknown" },
    { MM_PORT_TYPE_IGNORED, "MM_PORT_TYPE_IGNORED", "ignored" },
    { MM_PORT_TYPE_NET, "MM_PORT_TYPE_NET", "net" },
    { MM_PORT_TYPE_AT, "MM_PORT_TYPE_AT", "at" },
    { MM_PORT_TYPE_QCDM, "MM_PORT_TYPE_QCDM", "qcdm" },
    { MM_PORT_TYPE_GPS, "MM_PORT_TYPE_GPS", "gps" },
    { MM_PORT_TYPE_QMI, "MM_PORT_TYPE_QMI", "qmi" },
    { MM_PORT_TYPE_MBIM, "MM_PORT_TYPE_MBIM", "mbim" },
    { 0, NULL, NULL }
};

/* Define type-specific symbols */
#undef __MM_IS_ENUM__
#undef __MM_IS_FLAGS__
#define __MM_IS_ENUM__

GType
mm_port_type_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_enum_register_static (g_intern_static_string ("MMPortType"),
                                      mm_port_type_values);
        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * mm_port_type_get_string:
 * @val: a MMPortType.
 *
 * Gets the nickname string for the #MMPortType specified at @val.
 *
 * Returns: (transfer none): a string with the nickname, or %NULL if not found. Do not free the returned value.
 */
#if defined __MM_IS_ENUM__
const gchar *
mm_port_type_get_string (MMPortType val)
{
    guint i;

    for (i = 0; mm_port_type_values[i].value_nick; i++) {
        if (val == mm_port_type_values[i].value)
            return mm_port_type_values[i].value_nick;
    }

    return NULL;
}
#endif /* __MM_IS_ENUM_ */

/**
 * mm_port_type_build_string_from_mask:
 * @mask: bitmask of MMPortType values.
 *
 * Builds a string containing a comma-separated list of nicknames for
 * each #MMPortType in @mask.
 *
 * Returns: (transfer full): a string with the list of nicknames, or %NULL if none given. The returned value should be freed with g_free().
 */
#if defined __MM_IS_FLAGS__
gchar *
mm_port_type_build_string_from_mask (MMPortType mask)
{
    guint i;
    gboolean first = TRUE;
    GString *str = NULL;

    for (i = 0; mm_port_type_values[i].value_nick; i++) {
        /* We also look for exact matches */
        if (mask == mm_port_type_values[i].value) {
            if (str)
                g_string_free (str, TRUE);
            return g_strdup (mm_port_type_values[i].value_nick);
        }

        /* Build list with single-bit masks */
        if (mask & mm_port_type_values[i].value) {
            guint c;
            gulong number = mm_port_type_values[i].value;

            for (c = 0; number; c++)
                number &= number - 1;

            if (c == 1) {
                if (!str)
                    str = g_string_new ("");
                g_string_append_printf (str, "%s%s",
                                        first ? "" : ", ",
                                        mm_port_type_values[i].value_nick);
                if (first)
                    first = FALSE;
            }
        }
    }

    return (str ? g_string_free (str, FALSE) : NULL);
}
#endif /* __MM_IS_FLAGS__ */

/* enumerations from "./mm-port-serial-at.h" */
static const GFlagsValue mm_port_serial_at_flag_values[] = {
    { MM_PORT_SERIAL_AT_FLAG_NONE, "MM_PORT_SERIAL_AT_FLAG_NONE", "none" },
    { MM_PORT_SERIAL_AT_FLAG_PRIMARY, "MM_PORT_SERIAL_AT_FLAG_PRIMARY", "primary" },
    { MM_PORT_SERIAL_AT_FLAG_SECONDARY, "MM_PORT_SERIAL_AT_FLAG_SECONDARY", "secondary" },
    { MM_PORT_SERIAL_AT_FLAG_PPP, "MM_PORT_SERIAL_AT_FLAG_PPP", "ppp" },
    { MM_PORT_SERIAL_AT_FLAG_GPS_CONTROL, "MM_PORT_SERIAL_AT_FLAG_GPS_CONTROL", "gps-control" },
    { 0, NULL, NULL }
};

/* Define type-specific symbols */
#undef __MM_IS_ENUM__
#undef __MM_IS_FLAGS__
#define __MM_IS_FLAGS__

GType
mm_port_serial_at_flag_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_flags_register_static (g_intern_static_string ("MMPortSerialAtFlag"),
                                      mm_port_serial_at_flag_values);
        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * mm_port_serial_at_flag_get_string:
 * @val: a MMPortSerialAtFlag.
 *
 * Gets the nickname string for the #MMPortSerialAtFlag specified at @val.
 *
 * Returns: (transfer none): a string with the nickname, or %NULL if not found. Do not free the returned value.
 */
#if defined __MM_IS_ENUM__
const gchar *
mm_port_serial_at_flag_get_string (MMPortSerialAtFlag val)
{
    guint i;

    for (i = 0; mm_port_serial_at_flag_values[i].value_nick; i++) {
        if (val == mm_port_serial_at_flag_values[i].value)
            return mm_port_serial_at_flag_values[i].value_nick;
    }

    return NULL;
}
#endif /* __MM_IS_ENUM_ */

/**
 * mm_port_serial_at_flag_build_string_from_mask:
 * @mask: bitmask of MMPortSerialAtFlag values.
 *
 * Builds a string containing a comma-separated list of nicknames for
 * each #MMPortSerialAtFlag in @mask.
 *
 * Returns: (transfer full): a string with the list of nicknames, or %NULL if none given. The returned value should be freed with g_free().
 */
#if defined __MM_IS_FLAGS__
gchar *
mm_port_serial_at_flag_build_string_from_mask (MMPortSerialAtFlag mask)
{
    guint i;
    gboolean first = TRUE;
    GString *str = NULL;

    for (i = 0; mm_port_serial_at_flag_values[i].value_nick; i++) {
        /* We also look for exact matches */
        if (mask == mm_port_serial_at_flag_values[i].value) {
            if (str)
                g_string_free (str, TRUE);
            return g_strdup (mm_port_serial_at_flag_values[i].value_nick);
        }

        /* Build list with single-bit masks */
        if (mask & mm_port_serial_at_flag_values[i].value) {
            guint c;
            gulong number = mm_port_serial_at_flag_values[i].value;

            for (c = 0; number; c++)
                number &= number - 1;

            if (c == 1) {
                if (!str)
                    str = g_string_new ("");
                g_string_append_printf (str, "%s%s",
                                        first ? "" : ", ",
                                        mm_port_serial_at_flag_values[i].value_nick);
                if (first)
                    first = FALSE;
            }
        }
    }

    return (str ? g_string_free (str, FALSE) : NULL);
}
#endif /* __MM_IS_FLAGS__ */


/* Generated data ends here */

